/*
 * MasterService.c
 *
 * Created: 23.11.2016 07:02:21
 *  Author: Admin
 */ 
#include <avr/io.h>
#include "MasterService.h"
#include "../Rs485Dev/scheduler.h"
 #include "../Rs485Dev/globalDef.h"

device_t device[10];
device_t *ptrDevice;

#define timeOutID 55
bool bTimeOut;

master_state_t master_state;

void initMasterService()
{
	
	device[0].adr = 0x44;
	device[1].adr = 0x45;
	device[2].adr = 0xff;
	DDRB |= (1 << PINB5);
	master_state = STATE_GET_SWITCH;
}

void netTimeOut()
{
	ptrDevice->errorCount++;
	bTimeOut = true;
}

void NetMasterService(st_protokoll_Data* RxFrame)
{
	NOP;
	if(ptrDevice->adr == RxFrame->TxAddress)
	{
		memcpy (&ptrDevice->lastData,&RxFrame->Data[0],RxFrame->DataLength);
		if(SEND_ACK(RxFrame->InfoByte)) Net_SendAck(RxFrame->TxAddress);
		ptrDevice->newData = true;
	}
	PINB |= (1<<PINB5);
}
	

void slaveButtonState(void)
{
	unsigned char buf[5];
	buf[0] = 0x02;
	bTimeOut = false;
	ptrDevice = &device[0];
	ptrDevice->newData = false;
	Net_SendChar(device[0].adr,&buf[0],1,CRC_BIT);
	master_state = STATE_WAIT_FOR_SWITCH;
}

void slaveSetLight(void)
{
	unsigned char buf[5];
	buf[0] = 0x01;
	buf[1] = device[0].lastData[0];
	bTimeOut = false;
	ptrDevice = &device[1];
	ptrDevice->newData = false;
	Net_SendChar(ptrDevice->adr,&buf[0],2,CRC_BIT);
	master_state = STATE_WAIT_FOR_LIGHT;
}

void masterService(void)
{
	switch(master_state)
	{
		case STATE_GET_SWITCH:
		slaveButtonState();
		break;
		case STATE_WAIT_FOR_SWITCH:
		if(ptrDevice->newData) master_state = STATE_SET_LIGHT;
		break;
		case  STATE_SET_LIGHT:
		slaveSetLight();
		break;
		case STATE_WAIT_FOR_LIGHT:
		if(ptrDevice->newData) master_state = STATE_GET_SWITCH;
		break;
		
		
	}
	
}
