/*
 * RS485_Slave.c
 *
 * Created: 20.11.2016 15:06:21
 *  
 */ 
#include "../Rs485Dev/globalDef.h"
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <stdio.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "../Rs485Dev/RS485.h"
#include "../Rs485Dev/timer.h"
#include "../Rs485Dev/scheduler.h"
#include "../Rs485Dev/FloorLight.h"
#include "../Rs485Dev/button.h"
#include "floorLightService.h"

int main(void)
{
	st_Dev_Config my_Dev_config;
	
	my_Dev_config.fptrCallBackOnOk = NetFloorLight;
	my_Dev_config.MasterMode = false;	// Jetzt bin ich nur ein Slave <-------------------------------------------
	my_Dev_config.MyAdr = 0x45;			// oder aus EEProm auslesen
	my_Dev_config.speed = 9600;
	NetInit(&my_Dev_config);
	
	timer0_init();
	initScheduler();
	initFloorLight();
	initFloorLightService();
	initButton();
	addTask(1, floorLightTask, 10);
	addTask(2,buttonTask,10);
	_delay_ms(200);
	sei();
    while(1)
    {
	dispatchTasks();
    floorLight();
	
    }
}