/*
 * Rs485Dev.c
 *
 * Created: 11.11.2016 06:22:25
 * 
 */ 


#include "globalDef.h"
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <stdio.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "RS485.h"

#include "timer.h"
#include "scheduler.h"
#include "FloorLight.h"
#include "button.h"



	
volatile bool DataOk;
bool LCD_Update;
unsigned char LCD_buf[20];




void Send_Interger(unsigned char ptr_RXAddress,unsigned int *val)
{
	multiVal_t multiVal;
	multiVal.iVal = *val;
	Net_SendChar(ptr_RXAddress,&multiVal.cVal[0],2);
	
}

void Send_Float(unsigned char ptr_RXAddress,float *val)
{
	multiVal_t multiVal;
	multiVal.fVal = *val;
	Net_SendChar(ptr_RXAddress,&multiVal.cVal[0],4);
}



#define SET_LED 0x01
#define GET_INPUT 0x02
#define RESET 0x03
#define SET_PWM 0x04
#define GET_ADC 0x05
#define START_BOOTLOADER 0x06
#define WRITE_LCD_BUFFER 0x07
#define SET_NET_ADR      0x08
/*  usw    */

void NetAktion(st_protokoll_Data* RxFrame)
{
	NOP;
	switch(RxFrame->Data[0])
	{
		case SET_LED:
			PORTC |= (1 <<RxFrame->Data[1]);
			Net_SendAck(RxFrame->TxAddress);
			break;
		case WRITE_LCD_BUFFER:
			memcpy (LCD_buf,&RxFrame->Data[1],(RxFrame->DataLength - (INCLUDE_CRC(RxFrame->InfoByte))));
			LCD_buf[(RxFrame->DataLength - (INCLUDE_CRC(RxFrame->InfoByte)))+1] = 0x00;
			LCD_Update = true;
			Net_SendAck(RxFrame->TxAddress);
			break;
		default:
			// Info an Master NO SERVICE AVAILABLE
		break;
		
	}
}

void blinkTask(void)
{
	PINB |= (1<<PINB5);
}


// Slave Main
int main(void) {
	unsigned char buf[20];
	DDRB = (1 << PINB5) | (1 << PINB2) | (1 << PINB1); // set PINB0 and PINB2 as output
	DDRB &= ~( 1 << PINB7);
	DDRC =0xff;
	
	st_Dev_Config my_Dev_config;
	
	my_Dev_config.fptrCallBackOnOk = NetAktion;
	my_Dev_config.MasterMode = false;	// Jetzt bin ich nur ein Slave <-------------------------------------------
	my_Dev_config.MyAdr = 0x44;			// oder aus EEProm auslesen
	my_Dev_config.speed = 9600;
	timer0_init();
	initScheduler();
	initFloorLight();
	initButton();
	NetInit(&my_Dev_config);
	_delay_ms(200);
	
	sei();
	
	addTask(1, blinkTask, 1000);
	addTask(2, floorLightTask, 10);
	addTask(3,buttonTask,10);
	button_state_t a;
	while (1) {
		dispatchTasks();
		a = getButtonState();
		if (a == STATE_CLICK){
			switch(getFloorLightState())
			{
				case STATE_OFF:
				setFloorLigt(STATE_FADE_ON);
				break;
				case STATE_ON:
				setFloorLigt(STATE_FADE_OFF);
				break;
			}
			}else if(a == STATE_LONG_CLICK)
			{
				switch(getFloorLightState())
			{
				case STATE_OFF:
				setFloorLigt(STATE_ON);
				break;
				case STATE_ON:
				setFloorLigt(STATE_OFF);
				break;
			}
			}
		/*Net_SendChar(0x01,&buf[0],1);
		if(LCD_Update)
		{
		//lcd_string(&LCD_buf);	 // da ich deine LCD Lib nicht habe ist das ausgeklammert.
		LCD_Update = false;	
		Net_SendAck(0x01);
		}*/
		
	

	} // while

} // main

// Master Main


/*
int main(void) {
	unsigned char buf[20];
	DDRB = (1 << PINB5) | (1 << PINB2); // set PINB0 and PINB2 as output
	DDRC =0xff;
	st_Dev_Config my_Dev_config;
	
	my_Dev_config.fptrCallBackOnOk = NetAktion;
	my_Dev_config.MasterMode = true;	// Jetzt bin ich der Master im Bus <--------------------------------------------------
	my_Dev_config.MyAdr = 0x01;			// oder aus EEProm auslesen
	my_Dev_config.speed = 9600;

	NetInit(&my_Dev_config);
	_delay_ms(200);
	sei();

	while (1) {
		
		_delay_ms(1000);
		buf[0] = WRITE_LCD_BUFFER;
		sprintf(&buf[1],"LED");
		Net_SendChar( 0x44,&buf[0],4);
		
		

	} // while

} // main
*/