/*
 * button.c
 *
 * Created: 22.11.2016 09:56:52
 *  
 */ 
#include <avr/io.h>
#include "button.h"

button_state_t button_state;

void initButton()
{
 DDRB &= ~( 1 << PINB7);
 button_state = B_STATE_OFF;
}

unsigned char getButtonInputState()
{
	return (PINB & ( 1 << PINB7));
}


button_state_t getButtonState()
{
	button_state_t temp = B_STATE_OFF;
	
	if(button_state > STATE_PRE_DOUBLE_CLICK)
		{
			temp = button_state;
			button_state = B_STATE_OFF;	
		}
	return temp;
}


void buttonTask()
{
	static unsigned int count = 0;
	if(button_state > STATE_PRE_DOUBLE_CLICK) return;
	
	if(!getButtonInputState())
	{
		switch(button_state)
		{
			case B_STATE_OFF:
				count = 0;
				button_state = B_STATE_ON;
				break;
			case B_STATE_ON:
				count++;
				break;
			case STATE_PRE_DOUBLE_CLICK:
				count++;
				break;
		}
		
		
	}else if(button_state == B_STATE_ON)
	{
		
			if(count >= LONG_CLICK)button_state = STATE_LONG_CLICK;
			if(count <= NORMAL_CLICK) button_state = STATE_CLICK;
				
	}
	
}
