/*
 * crc16.c
 *
 * Created: 19.11.2016 09:24:16
 *  
 */ 

#include "crc16.h"

unsigned int crc16;

void InitCRC(void) {
	crc16 = CRC16_INIT_VALUE;
}


unsigned int CalcCRC(unsigned char data) {
	unsigned char bitCount;
	unsigned char PolynomFlag;
	for (bitCount = 0; bitCount <8; bitCount++) {
		PolynomFlag = (crc16 &0x8000) != 0;
		crc16 <<= 1;
		if (data &0x80) {
			crc16 |= 1;
		}
		data <<= 1;
		if (PolynomFlag)
		crc16 ^= CRC16_POLYNOM;
	}
	
	return crc16;
}

uCRC16_t CalcCRCBuffer(unsigned char *data, unsigned int length)
{
	uCRC16_t result;
	
	InitCRC();
	for(int i =0; i<length; i++)
	{
		result.iCRC16 = CalcCRC(*data++);
	}
	result.iCRC16 = CalcCRC(0);
	result.iCRC16 = CalcCRC(0);
	
	return result;
}

bool CheckCRC(unsigned char *data, unsigned int length)
{
	bool result = false;
	uCRC16_t crc;
	int a;
	crc = CalcCRCBuffer(data,length);
	if((crc.cCRC16[CRC_LO]== *(data +length +1)) &&(crc.cCRC16[CRC_HI]== *(data +length)))
	{
	 result = true;
	}
#ifdef NO_CRC
	return true;
#endif	
	return result;
	
}