/*
 * timer.c
 *
 * Created: 21.11.2016 14:36:50
 *  
 */ 


#include <avr/io.h>
#include <avr/interrupt.h>

#include "timer.h"
#include "scheduler.h"

// initialize timer, interrupt and variable
void timer0_init()
{
	// set up timer with prescaler = 256
	TCCR0B |= (1 << CS00) | (1 << CS01);
	
	// initialize counter
	TCNT0 = 6;
	
	// enable overflow interrupt
	TIMSK0 |= (1 << TOIE0);
	
}

// TIMER0 overflow interrupt service routine
// called whenever TCNT0 overflows
ISR(TIMER0_OVF_vect)
{
	TCNT0 = 6;
	schedulerMainTask();
}